public inbox for cluster-cvs@sourceware.org
help / color / mirror / Atom feed
From: "Fabio M. Di Nitto" <fabbione@fedoraproject.org>
To: cluster-cvs-relay@redhat.com
Subject: cluster: STABLE3 - cman init: do a better check to umount configfs
Date: Fri, 27 Mar 2009 19:07:00 -0000	[thread overview]
Message-ID: <20090327190622.9378712020C@lists.fedorahosted.org> (raw)

Gitweb:        http://git.fedorahosted.org/git/cluster.git?p=cluster.git;a=commitdiff;h=795a8720eb1cffdf405500c41a2d17666fb9053a
Commit:        795a8720eb1cffdf405500c41a2d17666fb9053a
Parent:        b6b4535b787c9968c5b1e8f118fa4b7f04f691ef
Author:        Fabio M. Di Nitto <fdinitto@redhat.com>
AuthorDate:    Wed Mar 25 12:57:08 2009 +0100
Committer:     Fabio M. Di Nitto <fdinitto@redhat.com>
CommitterDate: Fri Mar 27 20:05:45 2009 +0100

cman init: do a better check to umount configfs

dlm is a configfs user. Once we modprobe dlm and mount configfs,
the "ls -1" check will always avoid configfs umount.

Do a very soft attempt to remove the kernel modules we load without failing
if they are in use. If we succeed to remove the modules and there are no
more users for configfs, then umount it.

One catch 22 note is that we need to modprobe -r configfs only after it is
umounted, so perform that operation exclusively after we umount.
No failure is reported or generated as there might be other users around.

Signed-off-by: Fabio M. Di Nitto <fdinitto@redhat.com>
---
 cman/init.d/cman.in |   13 ++++++++++++-
 1 files changed, 12 insertions(+), 1 deletions(-)

diff --git a/cman/init.d/cman.in b/cman/init.d/cman.in
index de90e31..3b38ca5 100644
--- a/cman/init.d/cman.in
+++ b/cman/init.d/cman.in
@@ -493,8 +493,9 @@ stop_configfs()
 	if mtab_configfs && [ -z "$(ls -1 /sys/kernel/config)" ]; then
 		errmsg=$( /bin/umount /sys/kernel/config 2>&1 )
 		if [ $? -ne 0 ]; then
-			echo -n $errmsg " "
+			return 1
 		fi
+		/sbin/modprobe -r configfs > /dev/null 2>&1 || true
 	fi
 	return 0
 }
@@ -568,6 +569,12 @@ stop_fence_xvmd()
 	return $?
 }
 
+unload_modules()
+{
+	/sbin/modprobe -r lock_dlm > /dev/null 2>&1 || true
+	/sbin/modprobe -r dlm > /dev/null 2>&1 || true
+}
+
 stop()
 {
 	echo "Stopping cluster: "
@@ -618,6 +625,10 @@ stop()
 		nok
 	fi
 
+	echo -n "   Unloading modules..."
+	unload_modules
+	ok
+
 	echo -n "   Unmounting configfs... "
 	if stop_configfs; then
 		ok


                 reply	other threads:[~2009-03-27 19:06 UTC|newest]

Thread overview: [no followups] expand[flat|nested]  mbox.gz  Atom feed

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20090327190622.9378712020C@lists.fedorahosted.org \
    --to=fabbione@fedoraproject.org \
    --cc=cluster-cvs-relay@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).